//+------------------------------------------------------------------+
//|                                                     forecast.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1
extern int Length=20;
extern ENUM_APPLIED_PRICE Price=0;

double FO[],hu[],hd[];
int init()
{
 IndicatorBuffers(3);
 SetIndexBuffer(0,hu); SetIndexStyle(0,DRAW_HISTOGRAM);
 SetIndexBuffer(1,hd); SetIndexStyle(1,DRAW_HISTOGRAM);
 SetIndexBuffer(2,FO);
 IndicatorShortName("Forecast Oscillator");

 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
 if(Bars<=3) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 int pos;
 double sx, sy, sxy, sx2, a, b, tsf;
 double Pr;
 int i, t;
 pos=limit;
 while(pos>=0)
 {
  t=Length;
  sx=0.;
  sy=0.;
  sxy=0.;
  sx2=0.;
  for (i=pos+Length;i>=pos+1;i--)
  {
   Pr=iMA(NULL, 0, 1, 0, MODE_SMA, Price, i);
   sy=sy+Pr;
   sx=sx+t;
   sx2=sx2+t*t;
   sxy=sxy+Pr*t;
   t--;
  }
  b=(Length*sxy-sx*sy)/(Length*sx2-sx*sx);
  a=(sy-b*sx)/Length;
  tsf=a+b;
  
  Pr=iMA(NULL, 0, 1, 0, MODE_SMA, Price, pos);
  if (Pr!=0.)
  {
   FO[pos]=100.*(Pr-tsf)/Pr;
  } 
  hu[pos] = EMPTY_VALUE;
  hd[pos] = EMPTY_VALUE;
   if (FO[pos]>0) hu[pos] = 1;
   if (FO[pos]<0) hd[pos] = 1;
  pos--;
 } 
 return(0);
}

